# -----------------------------------------------------------------------------
# $Id: CTCP.pm 875 2005-03-27 19:05:46Z topia $
# -----------------------------------------------------------------------------
# IRCMessage椫CTCPåФꡢCTCPåIRCMessageäꡣ
# -----------------------------------------------------------------------------
package CTCP;
use strict;
use warnings;
use Carp;
use UNIVERSAL;
use base qw(Tiarra::IRC::NewMessageMixin);

use SelfLoader;
SelfLoader->load_stubs;
1;
__DATA__

sub extract {
    # PRIVMSGNOTICEǤIRCMessageCTCPåޤƤ顢Ф֤
    # '\x01CTCP VERSION\x01\x01CTCP USERINFO\x01'Τ褦˰ĤΥåʣCTCPåޤޤƤϡ
    # 顼ƥȤʤǽ˸դäΤ֤󥳥ƥȤʤ鸫դäƤ֤
    # CTCPåФʤäϡundef(顼)ޤ϶()֤
    my $msg = shift;

    if (!defined $msg) {
	croak "CTCP::extract, Arg[0] is undef.\n";
    }
    if (!UNIVERSAL::isa($msg, __PACKAGE__->irc_message_class)) {
	croak "CTCP::extract, Arg[0] is bad ref: ".ref($msg)."\n";
    }

    if ($msg->command eq 'PRIVMSG' || $msg->command eq 'NOTICE') {
	__PACKAGE__->extract_from_text($msg->param(1));
    }
}

sub make {
    # CTCPåޤTiarra::IRC::Messageä֤
    #
    # $message: ޤCTCPå
    # $target : Tiarra::IRC::MessageκǽΥѥ᡼nickͥ̾롣
    # $command: PRIVMSGNOTICEΤɤΥޥɤǺ뤫ά줿NOTICEˤʤ롣
    my ($message,$target,$command) = @_;

    if (!defined $target) {
	croak "CTCP::make, Arg[1] is undef.\n";
    }
    if (!defined $command) {
	$command = 'NOTICE';
    }

    my $result = __PACKAGE__->construct_irc_message(
	Command => $command,
	Params => [$target,
		   __PACKAGE__->make_text($message),
		  ]);

    $result;
}

sub _low_level_dequote {
    my ($symbol) = @_;

    if ($symbol eq '0') {
	return "\x00";
    } elsif ($symbol eq 'n') {
	return "\x0a";
    } elsif ($symbol eq 'r') {
	return "\x0d";
    } elsif ($symbol eq "\x10") {
	return "\x10";
    } else {
	# error, but return.
	return $symbol;
    }
}

sub _ctcp_level_dequote {
    my ($symbol) = @_;

    if ($symbol eq 'a') {
	return "\x01";
    } elsif ($symbol eq "\x5c") {
	return "\x5c";
    } else {
	# error, but return.
	return $symbol;
    }
}

sub dequote {
    shift; # drop
    local $_ = shift;

    # 2nd Level
    s/\x10(.)/_low_level_dequote($1)/eg;

    # 1st Level
    s/\x5c(.)/_ctcp_level_dequote($1)/eg;

    $_;
}

sub extract_from_text {
    my $this = shift;
    grep {
	if (!wantarray) {
	    return $_;
	}
	1;
    } map {
	$this->dequote($1);
    } (shift =~ m/\x01(.*)\x01/g);
}

sub quote {
    shift; # drop
    local $_ = shift;
    # 1st Level
    s/\x5c/\x5c\x5c/g;
    s/\x01/\x5ca/g;

    # 2nd Level
    s/\x10/\x10\x10/g;
    s/\x00/\x100/g;
    s/\x0a/\x10n/g;
    s/\x0d/\x10r/g;

    $_;
}

sub make_text {
    my $this = shift;
    my @ctcps = map {
	"\x01" . $this->quote($_) . "\x01";
    } @_;
    return wantarray ? @ctcps : join('', @ctcps);
}

1;
