# -----------------------------------------------------------------------------
# $Id: Oper.pm 869 2005-03-27 08:52:27Z topia $
# -----------------------------------------------------------------------------
package Auto::Oper;
use strict;
use warnings;
use base qw(Module);
use Module::Use qw(Auto::Utils);
use Auto::Utils;
use Mask;
use Multicast;

sub new {
    my $class = shift;
    my $this = $class->SUPER::new(@_);
    $this;
}

sub message_arrived {
    my ($this,$msg,$sender) = @_;
    my @result = ($msg);

    my ($get_raw_ch_name,$reply,$reply_as_priv,$reply_anywhere,$get_full_ch_name)
	= Auto::Utils::generate_reply_closures($msg,$sender,\@result);

    my $op = sub {
	$sender->send_message($this->construct_irc_message(
				  Command => 'MODE',
				  Params => [$get_raw_ch_name->(),'+o',$msg->nick]));
    };

    # 饯饤ȤؤPRIVMSGǡrequest˥ޥåƤ뤫
    if ($sender->isa('IrcIO::Server') &&
	$msg->command eq 'PRIVMSG' &&
	Mask::match_array([$this->config->request('all')],$msg->param(1), 1)) {
	# ꤵ줿ͥϴΤСprivǤϤʤ
	my $ch_name = $msg->param(0);
	my ($ch_name_plain) = Multicast::detatch($ch_name);
	my $ch = $sender->channel($ch_name_plain);
	if (defined $ch) {
	    # ꤵ줿ͥˡ׵ԤäƤ뤫
	    if (defined $ch->names($msg->nick)) {
		# ʤȤϤƤɤΤʤϤ
		if (Mask::match_deep_chan([$this->config->mask('all')],$msg->prefix,$get_full_ch_name->())) {
		    # ʬϤʤȤäƤ뤫
		    my $myself = $ch->names($sender->current_nick);
		    if ($myself->has_o) {
			# ϤʤȤäƤ뤫
			my $target = $ch->names($msg->nick);
			if ($target->has_o) {
			    $reply->($this->config->oper('random'));
			} else {
			    $reply->($this->config->message('random'));
			    $op->();
			}
		    } else {
			$reply->($this->config->not_oper('random'));
		    }
		} else {
		    $reply->($this->config->deny('random'));
		}
	    } else {
		$reply_as_priv->($this->config->out('random'));
	    }
	} else {
	    $reply_as_priv->($this->config->private('random'));
	}
    }
    return @result;
}

1;

=pod
info: ʸȯͤ+o롣
default: off
section: important

# Auto::AliasͭˤƤСꥢִԤʤޤ

# +o׵᤹ʸ(ޥ)ꤷޤ
request: ʤȴۤ

# ͥ륪ڥ졼¤׵ᤷͤ׵ᤵ줿ͥ뤬
# ǻꤷޥ˰פʤä
# denyǻꤷʸȯ+oޤ
# ά줿ïˤ+oޤ
# 񼰤ϡ֥ͥ ȯԡפǤ
# ޥå󥰤Υ르ꥺϼ̤Ǥ
# 1. ͥ̾˥ޥåmaskƽ
# 2. ޤäȯԥޥ줿˥ޤǷ礹
# 3. Τ褦ˤ줿ޥȯԤΥޥå󥰤Ԥʤ̤+oǽȤ롣
# 1:
# mask: *@2ch* *!*@*
# mask: #*@ircnet* *!*@*.hoge.jp
# Ǥϥͥåȥ 2ch ƤΥͥïˤǤ +o 
# ͥåȥ ircnet  # ǻϤޤƤΥͥǥۥ̾ *.hoge.jp οͤ+oޤ
# #*@ircnetȡ#hoge@ircnet:*.jpפʤɤ˥ޥåʤʤޤ
# 2:
# mask: #hoge@ircnet -*!*@*,+*!*@*.hoge.jp
# mask: *            +*!*@*
# ŪƤΥͥïˤǤ +o 뤬㳰Ū#hoge@ircnetǤ
# ۥ̾ *.hoge.jp οͤˤ +o ʤ
# ν岼դˤȡƤΥͥƤοͤ +o ˤʤޤ
# Τʤǽ* +*!*@*Ƥοͤ˥ޥå뤫Ǥ
mask: * *!*@*

# +o׵ᤷͤºݤ+oǻꤷȯ򤷤Ƥ+oޤ
# #(name|nick)Τ褦ʥꥢִԤޤ
# ꥢʳǤ⡢#(nick.now)nickˡ#(channel)
# Υͥ̾ˤ줾ִޤ
message: λ

# +o׵ᤵ줿+o٤ǤϤʤäȯ
# ά줿鲿ޤ
deny: Ǥ

# +o׵ᤵ줿ϴ˥ͥ륪ڥ졼¤äƤȯ
# ά줿denyꤵ줿ΤȤޤ
oper: @äƤ

# +o׵ᤵ줿ʬϥͥ륪ڥ졼¤äƤʤäȯ
# ά줿denyꤵ줿ΤȤޤ
not-oper: @̵

# ͥФƤǤʤʬФ+o׵Ԥʤäȯ
# ά줿denyꤵ줿ΤȤޤ
private: ͥ׵᤻

# ͥγ+o׵ᤵ줿ȯ+nͥǤϵޤ
# ά줿denyꤵ줿ΤȤޤ
out: ͥäƤʤ
=cut
