;; -*- emacs-lisp -*-
;; ----------------------------------------------------------------------------
;; $Id: tiarra-conf.el 479 2004-08-20 23:55:47Z topia $
;; ----------------------------------------------------------------------------
;; tiarra.confԽѥ⡼ɡ
;; ----------------------------------------------------------------------------

;; ޥå
(defvar tiarra-conf-mode-map
  (let ((map (make-keymap)))
    (define-key map "\M-n" 'tiarra-conf-next-block)
    (define-key map "\M-p" 'tiarra-conf-prev-block)
    (define-key map [?\C-c?\C-.] 'tiarra-conf-jump-to-block)
    (define-key map "\C-c." 'tiarra-conf-jump-to-block)
    map)
  "Keymap for tiarra conf mode.")

;; ʸ
(defvar tiarra-conf-mode-syntax-table nil
  "Syntax table used while in tiarra conf mode.")
(if tiarra-conf-mode-syntax-table
    ()   ; ʸơ֥뤬¸ʤιʤ
  (setq tiarra-conf-mode-syntax-table (make-syntax-table))
  (modify-syntax-entry ?{ "(}")
  (modify-syntax-entry ?} "){"))

;; ά
(defvar tiarra-conf-mode-abbrev-table nil
  "Abbrev table used while in tiarra conf mode.")
(define-abbrev-table 'tiarra-conf-mode-abbrev-table ())

;; եå
(defvar tiarra-conf-mode-hook nil
  "Normal hook runs when entering tiarra-conf-mode.")

(defun tiarra-conf-mode ()
  "Major mode for editing tiarra conf file.
\\{tiarra-conf-mode-map}
Turning on tiarra-conf-mode runs the normal hook `tiarra-conf-mode-hook'."
  (interactive)
  (kill-all-local-variables)
  (use-local-map tiarra-conf-mode-map)
  (set-syntax-table tiarra-conf-mode-syntax-table)
  (setq local-abbrev-table tiarra-conf-mode-abbrev-table)
  (setq mode-name "Tiarra-Conf")
  (setq major-mode 'tiarra-conf-mode)

  ;; եȥå
  (make-local-variable 'font-lock-defaults)
  (setq tiarra-conf-font-lock-keywords
	(list '("^[\t ]*#.*$"
		. font-lock-comment-face) ; 
	      '("^[\t ]*@.*$"
		. font-lock-warning-face) ; @ʸ
	      '("^[\t ]*\\+[\t ]+.+$"
		. font-lock-type-face) ; + ⥸塼
	      '("^[\t ]*-[\t ]+.+$"
		. font-lock-constant-face) ; - ⥸塼 
	      '("^[\t ]*\\([^:\n]+\\)\\(:\\).*$"
		(1 font-lock-variable-name-face) ; key
		(2 font-lock-string-face)) ; ':'
	      '("^[\t ]*[^{}\n]+"
		. font-lock-function-name-face))) ; ֥å̾
  (setq font-lock-defaults '(tiarra-conf-font-lock-keywords t))

  ;; mmm-mode
  (if (featurep 'mmm-auto)
      (progn
	(mmm-add-group
	 'embedding-in-tconf
	 '((pre-in-tconf
	    :submode perl
	    :front   "%PRE{"
	    :back    "}ERP%")
	   (code-in-tconf
	    :submode perl
	    :front   "%CODE{"
	    :back    "}EDOC%")))
	(setq mmm-classes 'embedding-in-tconf)
	(mmm-mode-on)))
  
  (run-hooks 'tiarra-conf-mode-hook))

(defun tiarra-conf-next-token ()
  "ȥХåեθߤΥ֤鼡Υȡõ֤
ϤΥȡνϤΰ֤ذư롣

֤ΤϼΤ䤦ʥꥹȤǤ롣
\(\"ȡ\" ')
:
  pair       -> ͤΥڥ
  label      -> ֥åΥ٥
  blockstart -> ֥åγϵ
  blockend   -> ֥åνλ

ȡ̵nil֤"
  (catch 'tiarra-conf-next-token
    ;; ޤ϶ȥȤФ
    ;; @ʸ%PRE%CODEФ
    ;; ġĤֺǾספλȤؤʤElisp-Regex
    ;; ɤĤ%PRE˰פΤʬʤ
    ;; ơ
    (or (re-search-forward "^\\([\n\t ]\\|#.*\\|@.*\\)*" nil t 1)
	(throw 'tiarra-conf-next-token nil))
    
    ;; ": "ηǤСԤνϤޤǤȡ
    (let* ((keychar "[^{}:\n\t ]") ; ȤƵʸ
	   (pair (concat keychar "+[\t ]*:.*")) ; ͤΥڥ
	   
	   ;; ϢĤΥϡȤƥ٥̾˵
	   (labelchar "\\([^-{}\n\t ]\\|::\\)") ; ֥å̾ȤƵʸ
	   (label (concat "\\(\\(\\+\\|-\\)[\t ]+\\)?" labelchar "+")) ;; ֥åΥ٥
	   
	   (blockstart "{") ;; ֥åγ
	   (blockend "}") ;; ֥åνλ
	   
	   type)
      (setq type
	    (cond ((looking-at pair) 'pair)
		  ((looking-at label) 'label)
		  ((looking-at blockstart) 'blockstart)
		  ((looking-at blockend) 'blockend)))
      (if (null type)
	  nil
	(prog1 (list (buffer-substring (point) (match-end 0))
		     type)
	  (goto-char (match-end 0)))))))

(defun tiarra-conf-next-block (&optional n)
  "nܤΥ֥åΰ֤إư롣
nϾάǽǡά줿`1'
֥åդĤϡΥ٥γϰ֤֤"
  (interactive "p")
  (catch 'tiarra-conf-next-block
    (setq n (if (numberp n) n 1))
    
    (if (< n 0)
	(throw 'tiarra-conf-next-block (tiarra-conf-prev-block (* -1 n))))
    (if (= n 0)
	(throw 'tiarra-conf-next-block nil))
    
    ;; ԤƬذư
    (beginning-of-line)
    
    (let (result token)
      ;; labelԤޤǥȡõ
      (while (progn
	       (setq token (tiarra-conf-next-token))
	       ;; tokennilޤlabelʤ齪λ
	       (if (or (null token)
		       (eq (cadr token) 'label))
		   nil
		 ;; labelʳΥȡʤΤǡ
		 t)))
      (if (null token)
	  ;; ȡ̵ǽϤꡣ
	  nil
	(setq result (point))
	;; "{"μʸذư
	(re-search-forward "{" nil t 1)
	(re-search-forward "[^\n\t ]" nil t 1)
	(backward-char)
	
	;; n2ʾä⤦١
	(if (> n 1)
	    (tiarra-conf-next-block (1- n))
	  result)))))

(defun tiarra-conf-prev-block (&optional n)
  "nܤΥ֥åΰ֤إư롣
nϾάǽǡά줿`1'
֥åդĤϡΥ٥γϰ֤֤"
  (interactive "p")
  (catch 'tiarra-conf-prev-block
    (setq n (if (numberp n) n 1))
    (setq n (1+ n))
    
    (if (< n 0)
	(throw 'tiarra-conf-prev-block (tiarra-conf-next-block (* -1 n))))

    ;; ޤżΥ֥åõơΰ֤Ͽ롣nilʤnilɤ
    (let ((next-block-pos
	   (save-excursion (tiarra-conf-next-block)))
	  current-block-pos)
      ;; ԤŤĥᤷĤġּΡץ֥åõƤߤ롣
      ;; next-block-pos¸ߤ֥åդ顢ǻߤ롣
      (while (progn
	       (beginning-of-line)
	       (if (= (point) (point-min))
		   ;; ʾˤʤ
		   nil
		 ;; ޤ롣
		 (previous-line)
		 (setq current-block-pos
		       (save-excursion (tiarra-conf-next-block)))
		 ;; ǽ˸դּΡץ֥ånilĤꡢ
		 ;; ŸդּΡץ֥åȺǽΤ줬ۤĤƤ𤿤ꤹ
		 ;; ֤ƽλ롣ǤʤƱ֤
		 (eq current-block-pos next-block-pos))))

      ;; n2ʾĤ⤦١
      (if (> n 1)
	  ;; ֤Ƭ᤹
	  (progn (beginning-of-line)
		 (tiarra-conf-prev-block (- n 2)))
	;; Ŭڤʰ֤ذưત
	;; tiarra-conf-next-blockƤ֡
	(tiarra-conf-next-block)
	current-block-pos))))

(defun tiarra-conf-join (delimitor sequence)
  "perljoin(delimitor, sequence)Ʊ"
  (let (result join)
    (setq join (lambda (elem)
		 (setq result (if (null result)
				  elem
				(concat result delimitor elem)))))
    (mapcar join sequence)
    result))

(defun tiarra-conf-jump-to-block ()
  "confˤ֥å̾Ϥξ˥פ륳ޥɡ"
  (interactive)
  (let (comp-list ;; competing-readǻȤalist ("֥å̾" . labelȡľΰ)
	parsing-block-stack ;; ("֥å̾" ...)
	blockname-to-jump
	point-to-jump)
    (save-excursion
      ;; եƬ
      (goto-char (point-min))
      ;; ĤŤĥȡ򸫤ƹԤlabel򸫤鵭Ͽ롣
      (while (let (token type blockname)
	       (setq token (tiarra-conf-next-token))
	       (if (null token)
		   ;; ⤦ȡ̵
		   nil
		 (setq type (cadr token))
		 (cond ((eq type 'label)
			;; ̎ގێ(ώ)
			(setq blockname (car token))
			(if (string-match "^[-+][\t ]+" blockname) ; +-ϼ롣
			    (setq blockname (replace-match "" nil nil blockname)))
			(push blockname parsing-block-stack)
			(setq comp-list
			      (append comp-list
				      (list (cons
					     (tiarra-conf-join " - " (reverse parsing-block-stack))
					     (point))))))
		       ((eq type 'blockend)
			;; ̎ގێ()؎
			(pop parsing-block-stack)))
		 t)))
      ;; ֥å̾ʹ
      (let ((completion-ignore-case t)) ; ŪˤˤtˡưŪפ͡ġ
	(setq blockname-to-jump (completing-read
				 "פ֥å: "
				 comp-list nil t)))
      (setq point-to-jump (cdr (assoc blockname-to-jump comp-list))))
    (if point-to-jump
	;; Ŭڤʰ֤إư
	(progn
	  (goto-char point-to-jump)
	  (beginning-of-line)
	  (tiarra-conf-next-block)))))
      
	
